/*			Question 2				*/			

% to start the program type start.
% The first section is an interpreter and user interface
% --------------------- ---------------------

start :- 	myretract,
		myinput_assert, 
		recommendation(R, S), 
		my_output(R,S).

myretract:- 
		retract(lost_call(L)),
		retract(single_focus_of_demand(S)),
		retract(duration(D)).
myretract.	

myinput_assert :- 
		nl,
		write('Please, enter number of lost call:		'), 
		read(Lost_call), assert(lost_call(Lost_call)), 
		write('Please, enter the duration:			'), 
		read(D), assert(duration(D)),
		write('There is a single focus of demand (y/n?	)'), 
		read(Single_focus_of_demand),
		assert(single_focus_of_demand(Single_focus_of_demand)).

my_output(R, S) :- 
		write(' The KBS recommend:   '), write(S), nl, 
		write('This recommendation is based on the rule number:   '), write(R),nl,nl.

% The following section is the knowledge-base
% --------------------- ---------------------

recommendation(R, S):- 
		problem(rule1, problem_extent_is_zero),
		R = rule6, S = no_intervention.

recommendation(R, S):-
		problem(rule4, problem_is_focused_overload),
		duration(D), D > 1,
		R = rule7, S = call_gapping.

recommendation(R, S):-
		problem(rule4, problem_is_focused_overload),
		duration(D), D =< 1,
		R = rule8, S = no_intervention_is_recommended.

recommendation(R, S ):-
		problem(rule5, problem_is_congestion),
		duration(D), D =< 1,
		R =rule9, S = trunk_reservation_factor_is_recommended.

recommendation(R,S):-
		problem(rule5, problem_is_congestion),
		duration(D), D > 1, D <4,
		R =rule10,  S = rerouting_secondary_traffic_is_recommended.

recommendation(R,S):-
		problem(rule5, problem_is_congestion),
		duration(D),  D > 4,
		R = rule11,S = rerouting_secondary_traffic_is_recommended.

% Problem rule 4 and 5 with the or 
% ------------------------------------------

problem(rule4, problem_is_focused_overload):- 
		problem_extent(rule2, problem_extent_is_minor),
		single_focus_of_demand(y).

problem(rule4, problem_is_focused_overload):- 
		problem_extent(rule3, problem_extent_is_major),
		single_focus_of_demand(y).

problem(rule5, problem_is_congestion):- 
		problem_extent(rule2, problem_extent_is_minor),
		single_focus_of_demand(n).

problem(rule5, problem_is_congestion):- 
		problem_extent(rule3, problem_extent_is_major),
		single_focus_of_demand(n).


problem(rule1, problem_extent_is_zero):- 
		problem_extent(rule1, problem_extent_is_zero).


% Problem extent rules 1 to 3   
% --------------------- ---------------------
problem_extent(rule1, problem_extent_is_zero):- 
		lost_call(Lost_call), 
		Lost_call= 0.
		
problem_extent(rule2, problem_extent_is_minor):- 
		lost_call(Lost_call), 
		Lost_call > 0,
		Lost_call < 10.
problem_extent(rule3, problem_extent_is_major):- 
		lost_call(Lost_call), 
		Lost_call >= 10.
